﻿// Star-wars style text scroll with random names
//
// Jim Bumgardner

SW = Stage.width; // scene width
SH = Stage.height; // scene height

  var adjlist = ["Untamed", "Naugahyde", "Carnivorous", "Herbivorous", "Pesky", "Irritatingly Perky",
                 "Randomly-generated", "Unending", "Pulchritudinous", "Slug-like",
                 "Pittardesque", "Unloved", "Spam®merific", "Genetically Engineered",
                 "Inforiffic", "Deciduous", "Coniferous", "Velvety Smooth", "Nubile", "Satanic",
                 "Unholy", "Beautific", "Miasma-inducing"];

  var modlist = ["Love", "Data", "Bit", "Web", "Nerve", "Neuro", "Tuber", "Lobster", "Info",
                 "'Tainment", "Tato", "Spam", "Cheese", "Wiener",  "Whiner",  "Bitrot",
                 "Lethargy", "Ennui", "Malaise", "Angst", "Phobia", "Rodent", "Weasel"];

  var nounlist = ["-fest", "-center", "-pod", "-site", "-pipe", " Portal", "-tub", " Hut", " Shack",
                  "-nexus", " Conglomeration", " Company", "-track", " Pit", " Pudding",
                  " Dog", " Support Group"];

function makeName()
{
  var adj = adjlist[random(adjlist.length)];
  var mod = modlist[random(modlist.length)];
  var noun = nounlist[random(nounlist.length)];

  switch (random(5)) {
   case 0:
    noun += "®";
    break;
   case 1:
    noun += "(tm)";
    break;
  }
  return "The " + adj + " " + mod + noun;
}

MovieClip.prototype.initText = function()
{
	this.title_fld.text = makeName();
}

kStartScale = 100;
kEndScale   = 1;
kStartAlpha = 0;
kStartY     = SH;
kMidAlpha   = .33;
kEffectTime = 8000;  // 4 seconds

function cycleText()
{
	var elapsed = (getTimer()+this.phase*kEffectTime) / kEffectTime;
	var ir = Math.floor(elapsed);
	if (ir != this.ctr) {
		this.initText();
		this.ctr = ir;
	}
	var r = elapsed - ir;
	// Fix r to move logarithmically here
	var lr = Math.log(1+r*(Math.E-1));
	this._xscale = kStartScale + (kEndScale - kStartScale)*lr;
	this._yscale = this._xscale;
	this._y = kStartY + (kEndY - kStartY)*lr;
	if (lr < kMidAlpha)
		this._alpha = 100*lr/kMidAlpha;
	else {
		lr = (lr-kMidAlpha)/(1-kMidAlpha);
		this._alpha = 100-lr*60;
	}
}

// trace(makeName());
var kNbrNames = 16;
for (var i = 0; i < kNbrNames; ++i) 
{
	var mc = this.attachMovie("title_mc", "title_mc_"+i, i);
	mc.initText();
	mc.phase = i/kNbrNames;
	mc._x = SW/2;
	mc.idx = i;
	mc.title_fld.textColor = 0x000000;
	mc.title_fld.autoSize = "center";
	mc.onEnterFrame = cycleText;
}
